# PA165 Java Enterprise Applications - Semestral Project

## Project Description

**Project name**: Airport Manager

### Assignment

Create an information system managing flight records at an airport. The system should allow the users to enter records about stewards, airplanes and destinations. It should also be possible to update and delete these records.

A destination should contain at least the information about the location of an airport (country, city). Airplane details should contain the capacity of the plane and its name (and possibly its type as well). A steward is described by his first and last name. The system should also allow us to record a flight.

When recording a flight, it is necessary to set the departure and arrival times, the origin, the destination and the plane. The system should also check that the plane does not have another flight scheduled during the time of the this flight. It should also be possible to assign (remove) stewards to (from) a flight while checking for the steward's availability.

The ultimate goal is to have a system capable of listing flights ordered by date and displaying the flight details (origin, destination, departure time, arrival time, plane, list of stewards)

### Team Epsilon - Developers

- **Kryštof-Mikuláš Štys**
  - Team Leader
  - 493159@mail.muni.cz
- Matěj Gorgol
  - 540492@mail.muni.cz
- Jan Sýkora
  - 485598@mail.muni.cz
- Tomáš Tomala
  - 541685@mail.muni.cz
- Tereza Vrabcová
  - 485431@mail.muni.cz

### Executable Modules

- **Flight** Module
- **Airline** Module
- **Steward** Module
- **Plane** Module
- **Destination** Module

### User roles

- Airline Manager - SCOPE_test_1
- Airport Manager - SCOPE_test_2
- Steward

## Instructions

### Dependencies

- Java 17
- Maven 3.8.1^

### How to run

```bash
# Move to the root folder of the project.
cd airport-manager
mvn clean install
# Move into desired executable module 
cd flight-module
mvn spring-boot:run
```

Docker:

```bash
# Move to the root folder of the project.
cd airport-manager
mvn clean install
docker compose up
```


## Diagrams

### Use Case Diagram

![Use Case Diagram](documentation/useCaseDiagram.png)

### Class Diagram

![Class Diagram](documentation/classDiagram.png)

### DTO Diagrams

**Find DTO Diagram**:

![Find DTO Diagram](documentation/FindDTODiagram.png)

**Insert DTO Diagram**:

![Insert DTO Diagram](documentation/InsertDTODiagram.png)

**Update DTO Diagram**:

![Update DTO Diagram](documentation/UpdateDTODiagram.png)

## Generics

To ensure uniformity and consistency across individual modules, generic entities are implemented for each layer, along with corresponding generic interfaces.

### Example diagram for Service layer

![Generic Service Diagram](documentation/genericService.png)
